#ifndef JADE_STREAM_XSALSA20_AMD64_AVX2_API_H
#define JADE_STREAM_XSALSA20_AMD64_AVX2_API_H

#define JADE_STREAM_XSALSA20_AMD64_AVX2_KEYBYTES 32
#define JADE_STREAM_XSALSA20_AMD64_AVX2_NONCEBYTES 24
#define JADE_STREAM_XSALSA20_AMD64_AVX2_ALGNAME "XSalsa20/20"

#include <stdint.h>

int jade_stream_xsalsa20_amd64_avx2_xor(
 uint8_t *ciphertext,
 uint8_t *plaintext,
 uint64_t length,
 uint8_t *nonce, /*NONCEBYTES*/
 uint8_t *key /*KEYBYTES*/
);

int jade_stream_xsalsa20_amd64_avx2(
 uint8_t *stream,
 uint64_t length,
 uint8_t *nonce, /*NONCEBYTES*/
 uint8_t *key /*KEYBYTES*/
);

#endif
#ifndef JADE_STREAM_XSALSA20_AMD64_AVX_API_H
#define JADE_STREAM_XSALSA20_AMD64_AVX_API_H

#define JADE_STREAM_XSALSA20_AMD64_AVX_KEYBYTES 32
#define JADE_STREAM_XSALSA20_AMD64_AVX_NONCEBYTES 24
#define JADE_STREAM_XSALSA20_AMD64_AVX_ALGNAME "XSalsa20/20"

#include <stdint.h>

int jade_stream_xsalsa20_amd64_avx_xor(
 uint8_t *ciphertext,
 uint8_t *plaintext,
 uint64_t length,
 uint8_t *nonce, /*NONCEBYTES*/
 uint8_t *key /*KEYBYTES*/
);

int jade_stream_xsalsa20_amd64_avx(
 uint8_t *stream,
 uint64_t length,
 uint8_t *nonce, /*NONCEBYTES*/
 uint8_t *key /*KEYBYTES*/
);

#endif
#ifndef JADE_STREAM_XSALSA20_AMD64_REF_API_H
#define JADE_STREAM_XSALSA20_AMD64_REF_API_H

#define JADE_STREAM_XSALSA20_AMD64_REF_KEYBYTES 32
#define JADE_STREAM_XSALSA20_AMD64_REF_NONCEBYTES 24
#define JADE_STREAM_XSALSA20_AMD64_REF_ALGNAME "XSalsa20/20"

#include <stdint.h>

int jade_stream_xsalsa20_amd64_ref_xor(
 uint8_t *ciphertext,
 uint8_t *plaintext,
 uint64_t length,
 uint8_t *nonce, /*NONCEBYTES*/
 uint8_t *key /*KEYBYTES*/
);

int jade_stream_xsalsa20_amd64_ref(
 uint8_t *stream,
 uint64_t length,
 uint8_t *nonce, /*NONCEBYTES*/
 uint8_t *key /*KEYBYTES*/
);

#endif
#ifndef JADE_STREAM_SALSA20_SALSA2012_AMD64_AVX2_API_H
#define JADE_STREAM_SALSA20_SALSA2012_AMD64_AVX2_API_H

#define JADE_STREAM_SALSA20_SALSA2012_AMD64_AVX2_KEYBYTES 32
#define JADE_STREAM_SALSA20_SALSA2012_AMD64_AVX2_NONCEBYTES 8
#define JADE_STREAM_SALSA20_SALSA2012_AMD64_AVX2_ALGNAME "Salsa20/12"

#include <stdint.h>

int jade_stream_salsa20_salsa2012_amd64_avx2_xor(
 uint8_t *ciphertext,
 uint8_t *plaintext,
 uint64_t length,
 uint8_t *nonce, /*NONCEBYTES*/
 uint8_t *key /*KEYBYTES*/
);

int jade_stream_salsa20_salsa2012_amd64_avx2(
 uint8_t *stream,
 uint64_t length,
 uint8_t *nonce, /*NONCEBYTES*/
 uint8_t *key /*KEYBYTES*/
);

#endif
#ifndef JADE_STREAM_SALSA20_SALSA2012_AMD64_AVX_API_H
#define JADE_STREAM_SALSA20_SALSA2012_AMD64_AVX_API_H

#define JADE_STREAM_SALSA20_SALSA2012_AMD64_AVX_KEYBYTES 32
#define JADE_STREAM_SALSA20_SALSA2012_AMD64_AVX_NONCEBYTES 8
#define JADE_STREAM_SALSA20_SALSA2012_AMD64_AVX_ALGNAME "Salsa20/12"

#include <stdint.h>

int jade_stream_salsa20_salsa2012_amd64_avx_xor(
 uint8_t *ciphertext,
 uint8_t *plaintext,
 uint64_t length,
 uint8_t *nonce, /*NONCEBYTES*/
 uint8_t *key /*KEYBYTES*/
);

int jade_stream_salsa20_salsa2012_amd64_avx(
 uint8_t *stream,
 uint64_t length,
 uint8_t *nonce, /*NONCEBYTES*/
 uint8_t *key /*KEYBYTES*/
);


#endif
#ifndef JADE_STREAM_SALSA20_SALSA2012_AMD64_REF_API_H
#define JADE_STREAM_SALSA20_SALSA2012_AMD64_REF_API_H

#define JADE_STREAM_SALSA20_SALSA2012_AMD64_REF_KEYBYTES 32
#define JADE_STREAM_SALSA20_SALSA2012_AMD64_REF_NONCEBYTES 8
#define JADE_STREAM_SALSA20_SALSA2012_AMD64_REF_ALGNAME "Salsa20/12"

#include <stdint.h>

int jade_stream_salsa20_salsa2012_amd64_ref_xor(
 uint8_t *ciphertext,
 uint8_t *plaintext,
 uint64_t length,
 uint8_t *nonce, /*NONCEBYTES*/
 uint8_t *key /*KEYBYTES*/
);

int jade_stream_salsa20_salsa2012_amd64_ref(
 uint8_t *stream,
 uint64_t length,
 uint8_t *nonce, /*NONCEBYTES*/
 uint8_t *key /*KEYBYTES*/
);

#endif
#ifndef JADE_STREAM_SALSA20_SALSA20_AMD64_AVX2_API_H
#define JADE_STREAM_SALSA20_SALSA20_AMD64_AVX2_API_H

#define JADE_STREAM_SALSA20_SALSA20_AMD64_AVX2_KEYBYTES 32
#define JADE_STREAM_SALSA20_SALSA20_AMD64_AVX2_NONCEBYTES 8
#define JADE_STREAM_SALSA20_SALSA20_AMD64_AVX2_ALGNAME "Salsa20/20"

#include <stdint.h>

int jade_stream_salsa20_salsa20_amd64_avx2_xor(
 uint8_t *ciphertext,
 uint8_t *plaintext,
 uint64_t length,
 uint8_t *nonce, /*NONCEBYTES*/
 uint8_t *key /*KEYBYTES*/
);

int jade_stream_salsa20_salsa20_amd64_avx2(
 uint8_t *stream,
 uint64_t length,
 uint8_t *nonce, /*NONCEBYTES*/
 uint8_t *key /*KEYBYTES*/
);

#endif
#ifndef JADE_STREAM_SALSA20_SALSA20_AMD64_AVX_API_H
#define JADE_STREAM_SALSA20_SALSA20_AMD64_AVX_API_H

#define JADE_STREAM_SALSA20_SALSA20_AMD64_AVX_KEYBYTES 32
#define JADE_STREAM_SALSA20_SALSA20_AMD64_AVX_NONCEBYTES 8
#define JADE_STREAM_SALSA20_SALSA20_AMD64_AVX_ALGNAME "Salsa20/20"

#include <stdint.h>

int jade_stream_salsa20_salsa20_amd64_avx_xor(
 uint8_t *ciphertext,
 uint8_t *plaintext,
 uint64_t length,
 uint8_t *nonce, /*NONCEBYTES*/
 uint8_t *key /*KEYBYTES*/
);

int jade_stream_salsa20_salsa20_amd64_avx(
 uint8_t *stream,
 uint64_t length,
 uint8_t *nonce, /*NONCEBYTES*/
 uint8_t *key /*KEYBYTES*/
);

#endif
#ifndef JADE_STREAM_SALSA20_SALSA20_AMD64_REF_API_H
#define JADE_STREAM_SALSA20_SALSA20_AMD64_REF_API_H

#define JADE_STREAM_SALSA20_SALSA20_AMD64_REF_KEYBYTES 32
#define JADE_STREAM_SALSA20_SALSA20_AMD64_REF_NONCEBYTES 8
#define JADE_STREAM_SALSA20_SALSA20_AMD64_REF_ALGNAME "Salsa20/20"

#include <stdint.h>

int jade_stream_salsa20_salsa20_amd64_ref_xor(
 uint8_t *ciphertext,
 uint8_t *plaintext,
 uint64_t length,
 uint8_t *nonce, /*NONCEBYTES*/
 uint8_t *key /*KEYBYTES*/
);

int jade_stream_salsa20_salsa20_amd64_ref(
 uint8_t *stream,
 uint64_t length,
 uint8_t *nonce, /*NONCEBYTES*/
 uint8_t *key /*KEYBYTES*/
);

#endif
#ifndef JADE_STREAM_CHACHA_CHACHA20_IETF_AMD64_AVX2_API_H
#define JADE_STREAM_CHACHA_CHACHA20_IETF_AMD64_AVX2_API_H

#define JADE_STREAM_CHACHA_CHACHA20_IETF_AMD64_AVX2_KEYBYTES 32
#define JADE_STREAM_CHACHA_CHACHA20_IETF_AMD64_AVX2_NONCEBYTES 12
#define JADE_STREAM_CHACHA_CHACHA20_IETF_AMD64_AVX2_ALGNAME "ChaCha20-ietf"

#include <stdint.h>

int jade_stream_chacha_chacha20_ietf_amd64_avx2_xor(
 uint8_t *ciphertext,
 uint8_t *plaintext,
 uint64_t length,
 uint8_t *nonce, /*NONCEBYTES*/
 uint8_t *key /*KEYBYTES*/
);

int jade_stream_chacha_chacha20_ietf_amd64_avx2(
 uint8_t *stream,
 uint64_t length,
 uint8_t *nonce, /*NONCEBYTES*/
 uint8_t *key /*KEYBYTES*/
);

#endif
#ifndef JADE_STREAM_CHACHA_CHACHA20_IETF_AMD64_AVX_API_H
#define JADE_STREAM_CHACHA_CHACHA20_IETF_AMD64_AVX_API_H

#define JADE_STREAM_CHACHA_CHACHA20_IETF_AMD64_AVX_KEYBYTES 32
#define JADE_STREAM_CHACHA_CHACHA20_IETF_AMD64_AVX_NONCEBYTES 12
#define JADE_STREAM_CHACHA_CHACHA20_IETF_AMD64_AVX_ALGNAME "ChaCha20-ietf"

#include <stdint.h>

int jade_stream_chacha_chacha20_ietf_amd64_avx_xor(
 uint8_t *ciphertext,
 uint8_t *plaintext,
 uint64_t length,
 uint8_t *nonce, /*NONCEBYTES*/
 uint8_t *key /*KEYBYTES*/
);

int jade_stream_chacha_chacha20_ietf_amd64_avx(
 uint8_t *stream,
 uint64_t length,
 uint8_t *nonce, /*NONCEBYTES*/
 uint8_t *key /*KEYBYTES*/
);

#endif
#ifndef JADE_STREAM_CHACHA_CHACHA20_IETF_AMD64_REF_API_H
#define JADE_STREAM_CHACHA_CHACHA20_IETF_AMD64_REF_API_H

#define JADE_STREAM_CHACHA_CHACHA20_IETF_AMD64_REF_KEYBYTES 32
#define JADE_STREAM_CHACHA_CHACHA20_IETF_AMD64_REF_NONCEBYTES 12
#define JADE_STREAM_CHACHA_CHACHA20_IETF_AMD64_REF_ALGNAME "ChaCha20-ietf"

#include <stdint.h>

int jade_stream_chacha_chacha20_ietf_amd64_ref_xor(
 uint8_t *ciphertext,
 uint8_t *plaintext,
 uint64_t length,
 uint8_t *nonce, /*NONCEBYTES*/
 uint8_t *key /*KEYBYTES*/
);

int jade_stream_chacha_chacha20_ietf_amd64_ref(
 uint8_t *stream,
 uint64_t length,
 uint8_t *nonce, /*NONCEBYTES*/
 uint8_t *key /*KEYBYTES*/
);

#endif
#ifndef JADE_STREAM_CHACHA_CHACHA12_AMD64_AVX2_API_H
#define JADE_STREAM_CHACHA_CHACHA12_AMD64_AVX2_API_H

#define JADE_STREAM_CHACHA_CHACHA12_AMD64_AVX2_KEYBYTES 32
#define JADE_STREAM_CHACHA_CHACHA12_AMD64_AVX2_NONCEBYTES 8
#define JADE_STREAM_CHACHA_CHACHA12_AMD64_AVX2_ALGNAME "ChaCha12"

#include <stdint.h>

int jade_stream_chacha_chacha12_amd64_avx2_xor(
 uint8_t *ciphertext,
 uint8_t *plaintext,
 uint64_t length,
 uint8_t *nonce, /*NONCEBYTES*/
 uint8_t *key /*KEYBYTES*/
);

int jade_stream_chacha_chacha12_amd64_avx2(
 uint8_t *stream,
 uint64_t length,
 uint8_t *nonce, /*NONCEBYTES*/
 uint8_t *key /*KEYBYTES*/
);

#endif
#ifndef JADE_STREAM_CHACHA_CHACHA12_AMD64_AVX_API_H
#define JADE_STREAM_CHACHA_CHACHA12_AMD64_AVX_API_H

#define JADE_STREAM_CHACHA_CHACHA12_AMD64_AVX_KEYBYTES 32
#define JADE_STREAM_CHACHA_CHACHA12_AMD64_AVX_NONCEBYTES 8
#define JADE_STREAM_CHACHA_CHACHA12_AMD64_AVX_ALGNAME "ChaCha12"

#include <stdint.h>

int jade_stream_chacha_chacha12_amd64_avx_xor(
 uint8_t *ciphertext,
 uint8_t *plaintext,
 uint64_t length,
 uint8_t *nonce, /*NONCEBYTES*/
 uint8_t *key /*KEYBYTES*/
);

int jade_stream_chacha_chacha12_amd64_avx(
 uint8_t *stream,
 uint64_t length,
 uint8_t *nonce, /*NONCEBYTES*/
 uint8_t *key /*KEYBYTES*/
);

#endif
#ifndef JADE_STREAM_CHACHA_CHACHA12_AMD64_REF_API_H
#define JADE_STREAM_CHACHA_CHACHA12_AMD64_REF_API_H

#define JADE_STREAM_CHACHA_CHACHA12_AMD64_REF_KEYBYTES 32
#define JADE_STREAM_CHACHA_CHACHA12_AMD64_REF_NONCEBYTES 8
#define JADE_STREAM_CHACHA_CHACHA12_AMD64_REF_ALGNAME "ChaCha12"

#include <stdint.h>

int jade_stream_chacha_chacha12_amd64_ref_xor(
 uint8_t *ciphertext,
 uint8_t *plaintext,
 uint64_t length,
 uint8_t *nonce, /*NONCEBYTES*/
 uint8_t *key /*KEYBYTES*/
);

int jade_stream_chacha_chacha12_amd64_ref(
 uint8_t *stream,
 uint64_t length,
 uint8_t *nonce, /*NONCEBYTES*/
 uint8_t *key /*KEYBYTES*/
);


#endif
#ifndef JADE_STREAM_CHACHA_CHACHA20_AMD64_AVX2_API_H
#define JADE_STREAM_CHACHA_CHACHA20_AMD64_AVX2_API_H

#define JADE_STREAM_CHACHA_CHACHA20_AMD64_AVX2_KEYBYTES 32
#define JADE_STREAM_CHACHA_CHACHA20_AMD64_AVX2_NONCEBYTES 8
#define JADE_STREAM_CHACHA_CHACHA20_AMD64_AVX2_ALGNAME "ChaCha20"

#include <stdint.h>

int jade_stream_chacha_chacha20_amd64_avx2_xor(
 uint8_t *ciphertext,
 uint8_t *plaintext,
 uint64_t length,
 uint8_t *nonce, /*NONCEBYTES*/
 uint8_t *key /*KEYBYTES*/
);

int jade_stream_chacha_chacha20_amd64_avx2(
 uint8_t *stream,
 uint64_t length,
 uint8_t *nonce, /*NONCEBYTES*/
 uint8_t *key /*KEYBYTES*/
);

#endif
#ifndef JADE_STREAM_CHACHA_CHACHA20_AMD64_AVX_API_H
#define JADE_STREAM_CHACHA_CHACHA20_AMD64_AVX_API_H

#define JADE_STREAM_CHACHA_CHACHA20_AMD64_AVX_KEYBYTES 32
#define JADE_STREAM_CHACHA_CHACHA20_AMD64_AVX_NONCEBYTES 8
#define JADE_STREAM_CHACHA_CHACHA20_AMD64_AVX_ALGNAME "ChaCha20"

#include <stdint.h>

int jade_stream_chacha_chacha20_amd64_avx_xor(
 uint8_t *ciphertext,
 uint8_t *plaintext,
 uint64_t length,
 uint8_t *nonce, /*NONCEBYTES*/
 uint8_t *key /*KEYBYTES*/
);

int jade_stream_chacha_chacha20_amd64_avx(
 uint8_t *stream,
 uint64_t length,
 uint8_t *nonce, /*NONCEBYTES*/
 uint8_t *key /*KEYBYTES*/
);

#endif
#ifndef JADE_STREAM_CHACHA_CHACHA20_AMD64_REF_API_H
#define JADE_STREAM_CHACHA_CHACHA20_AMD64_REF_API_H

#define JADE_STREAM_CHACHA_CHACHA20_AMD64_REF_KEYBYTES 32
#define JADE_STREAM_CHACHA_CHACHA20_AMD64_REF_NONCEBYTES 8
#define JADE_STREAM_CHACHA_CHACHA20_AMD64_REF_ALGNAME "ChaCha20"

#include <stdint.h>

int jade_stream_chacha_chacha20_amd64_ref_xor(
 uint8_t *ciphertext,
 uint8_t *plaintext,
 uint64_t length,
 uint8_t *nonce, /*NONCEBYTES*/
 uint8_t *key /*KEYBYTES*/
);

int jade_stream_chacha_chacha20_amd64_ref(
 uint8_t *stream,
 uint64_t length,
 uint8_t *nonce, /*NONCEBYTES*/
 uint8_t *key /*KEYBYTES*/
);

#endif
#ifndef JADE_SECRETBOX_XSALSA20POLY1305_AMD64_AVX2_API_H
#define JADE_SECRETBOX_XSALSA20POLY1305_AMD64_AVX2_API_H

#define JADE_SECRETBOX_XSALSA20POLY1305_AMD64_AVX2_KEYBYTES 32
#define JADE_SECRETBOX_XSALSA20POLY1305_AMD64_AVX2_NONCEBYTES 24
#define JADE_SECRETBOX_XSALSA20POLY1305_AMD64_AVX2_ZEROBYTES 32
#define JADE_SECRETBOX_XSALSA20POLY1305_AMD64_AVX2_BOXZEROBYTES 16
#define JADE_SECRETBOX_XSALSA20POLY1305_AMD64_AVX2_ALGNAME "XSalsa20/20Poly1305"

#include <stdint.h>

int jade_secretbox_xsalsa20poly1305_amd64_avx2(
  uint8_t *ciphertext,
  const uint8_t *plaintext,
  uint64_t length,
  const uint8_t *nonce, /*NONCEBYTES*/
  const uint8_t *key /*KEYBYTES*/
);

int jade_secretbox_xsalsa20poly1305_amd64_avx2_open(
  uint8_t *plaintext,
  const uint8_t *ciphertext,
  uint64_t length,
  const uint8_t *nonce, /*NONCEBYTES*/
  const uint8_t *key /*KEYBYTES*/
);

#endif
#ifndef JADE_SECRETBOX_XSALSA20POLY1305_AMD64_AVX_API_H
#define JADE_SECRETBOX_XSALSA20POLY1305_AMD64_AVX_API_H

#define JADE_SECRETBOX_XSALSA20POLY1305_AMD64_AVX_KEYBYTES 32
#define JADE_SECRETBOX_XSALSA20POLY1305_AMD64_AVX_NONCEBYTES 24
#define JADE_SECRETBOX_XSALSA20POLY1305_AMD64_AVX_ZEROBYTES 32
#define JADE_SECRETBOX_XSALSA20POLY1305_AMD64_AVX_BOXZEROBYTES 16
#define JADE_SECRETBOX_XSALSA20POLY1305_AMD64_AVX_ALGNAME "XSalsa20/20Poly1305"

#include <stdint.h>

int jade_secretbox_xsalsa20poly1305_amd64_avx(
  uint8_t *ciphertext,
  const uint8_t *plaintext,
  uint64_t length,
  const uint8_t *nonce, /*NONCEBYTES*/
  const uint8_t *key /*KEYBYTES*/
);

int jade_secretbox_xsalsa20poly1305_amd64_avx_open(
  uint8_t *plaintext,
  const uint8_t *ciphertext,
  uint64_t length,
  const uint8_t *nonce, /*NONCEBYTES*/
  const uint8_t *key /*KEYBYTES*/
);

#endif
#ifndef JADE_SECRETBOX_XSALSA20POLY1305_AMD64_REF_API_H
#define JADE_SECRETBOX_XSALSA20POLY1305_AMD64_REF_API_H

#define JADE_SECRETBOX_XSALSA20POLY1305_AMD64_REF_KEYBYTES 32
#define JADE_SECRETBOX_XSALSA20POLY1305_AMD64_REF_NONCEBYTES 24
#define JADE_SECRETBOX_XSALSA20POLY1305_AMD64_REF_ZEROBYTES 32
#define JADE_SECRETBOX_XSALSA20POLY1305_AMD64_REF_BOXZEROBYTES 16
#define JADE_SECRETBOX_XSALSA20POLY1305_AMD64_REF_ALGNAME "XSalsa20/20Poly1305"

#include <stdint.h>

int jade_secretbox_xsalsa20poly1305_amd64_ref(
  uint8_t *ciphertext,
  const uint8_t *plaintext,
  uint64_t length,
  const uint8_t *nonce, /*NONCEBYTES*/
  const uint8_t *key /*KEYBYTES*/
);

int jade_secretbox_xsalsa20poly1305_amd64_ref_open(
  uint8_t *plaintext,
  const uint8_t *ciphertext,
  uint64_t length,
  const uint8_t *nonce, /*NONCEBYTES*/
  const uint8_t *key /*KEYBYTES*/
);

#endif
#ifndef JADE_HASH_SHA3_384_AMD64_AVX2_API_H
#define JADE_HASH_SHA3_384_AMD64_AVX2_API_H

#define JADE_HASH_SHA3_384_AMD64_AVX2_BYTES 48
#define JADE_HASH_SHA3_384_AMD64_AVX2_ALGNAME "SHA3-384"

#include <stdint.h>

int jade_hash_sha3_384_amd64_avx2(
 uint8_t *out,
 uint8_t *in,
 uint64_t length
);

#endif
#ifndef JADE_HASH_SHA3_384_AMD64_REF_API_H
#define JADE_HASH_SHA3_384_AMD64_REF_API_H

#define JADE_HASH_SHA3_384_AMD64_REF_BYTES 48
#define JADE_HASH_SHA3_384_AMD64_REF_ALGNAME "SHA3-384"

#include <stdint.h>

int jade_hash_sha3_384_amd64_ref(
 uint8_t *out,
 uint8_t *in,
 uint64_t length
);

#endif
#ifndef JADE_HASH_SHA3_224_AMD64_AVX2_API_H
#define JADE_HASH_SHA3_224_AMD64_AVX2_API_H

#define JADE_HASH_SHA3_224_AMD64_AVX2_BYTES 28
#define JADE_HASH_SHA3_224_AMD64_AVX2_ALGNAME "SHA3-224"

#include <stdint.h>

int jade_hash_sha3_224_amd64_avx2(
 uint8_t *out,
 uint8_t *in,
 uint64_t length
);

#endif
#ifndef JADE_HASH_SHA3_224_AMD64_REF_API_H
#define JADE_HASH_SHA3_224_AMD64_REF_API_H

#define JADE_HASH_SHA3_224_AMD64_REF_BYTES 28
#define JADE_HASH_SHA3_224_AMD64_REF_ALGNAME "SHA3-224"

#include <stdint.h>

int jade_hash_sha3_224_amd64_ref(
 uint8_t *out,
 uint8_t *in,
 uint64_t length
);

#endif
#ifndef JADE_HASH_SHA3_512_AMD64_AVX2_API_H
#define JADE_HASH_SHA3_512_AMD64_AVX2_API_H

#define JADE_HASH_SHA3_512_AMD64_AVX2_BYTES 64
#define JADE_HASH_SHA3_512_AMD64_AVX2_ALGNAME "SHA3-512"

#include <stdint.h>

int jade_hash_sha3_512_amd64_avx2(
 uint8_t *out,
 uint8_t *in,
 uint64_t length
);

#endif
#ifndef JADE_HASH_SHA3_512_AMD64_REF_API_H
#define JADE_HASH_SHA3_512_AMD64_REF_API_H

#define JADE_HASH_SHA3_512_AMD64_REF_BYTES 64
#define JADE_HASH_SHA3_512_AMD64_REF_ALGNAME "SHA3-512"

#include <stdint.h>

int jade_hash_sha3_512_amd64_ref(
 uint8_t *out,
 uint8_t *in,
 uint64_t length
);

#endif
#ifndef JADE_HASH_SHA256_AMD64_REF_API_H
#define JADE_HASH_SHA256_AMD64_REF_API_H

#define JADE_HASH_SHA256_AMD64_REF_BYTES 32
#define JADE_HASH_SHA256_AMD64_REF_ALGNAME "SHA256"

#include <stdint.h>

int jade_hash_sha256_amd64_ref(
 uint8_t *out,
 uint8_t *in,
 uint64_t length
);

#endif
#ifndef JADE_HASH_SHA3_256_AMD64_AVX2_API_H
#define JADE_HASH_SHA3_256_AMD64_AVX2_API_H

#define JADE_HASH_SHA3_256_AMD64_AVX2_BYTES 32
#define JADE_HASH_SHA3_256_AMD64_AVX2_ALGNAME "SHA3-256"

#include <stdint.h>

int jade_hash_sha3_256_amd64_avx2(
 uint8_t *out,
 uint8_t *in,
 uint64_t length
);

#endif
#ifndef JADE_HASH_SHA3_256_AMD64_REF_API_H
#define JADE_HASH_SHA3_256_AMD64_REF_API_H

#define JADE_HASH_SHA3_256_AMD64_REF_BYTES 32
#define JADE_HASH_SHA3_256_AMD64_REF_ALGNAME "SHA3-256"

#include <stdint.h>

int jade_hash_sha3_256_amd64_ref(
 uint8_t *out,
 uint8_t *in,
 uint64_t length
);

#endif
#ifndef JADE_KEM_KYBER_KYBER768_AMD64_AVX2_API_H
#define JADE_KEM_KYBER_KYBER768_AMD64_AVX2_API_H

#include <stdint.h>

#define JADE_KEM_KYBER_KYBER768_AMD64_AVX2_SECRETKEYBYTES  2400
#define JADE_KEM_KYBER_KYBER768_AMD64_AVX2_PUBLICKEYBYTES  1184
#define JADE_KEM_KYBER_KYBER768_AMD64_AVX2_CIPHERTEXTBYTES 1088
#define JADE_KEM_KYBER_KYBER768_AMD64_AVX2_BYTES           32
#define JADE_KEM_KYBER_KYBER768_AMD64_AVX2_ALGNAME         "Kyber768"

int jade_kem_kyber_kyber768_amd64_avx2_keypair(uint8_t *pk, uint8_t *sk);

int jade_kem_kyber_kyber768_amd64_avx2_enc(uint8_t *ct, uint8_t *ss, const uint8_t *pk);

int jade_kem_kyber_kyber768_amd64_avx2_dec(uint8_t *ss, const uint8_t *ct, const uint8_t *sk);

#endif
#ifndef JADE_KEM_KYBER_KYBER768_AMD64_REF_H
#define JADE_KEM_KYBER_KYBER768_AMD64_REF_H

#define JADE_KEM_KYBER_KYBER768_AMD64_REF_SECRETKEYBYTES  2400
#define JADE_KEM_KYBER_KYBER768_AMD64_REF_PUBLICKEYBYTES  1184
#define JADE_KEM_KYBER_KYBER768_AMD64_REF_CIPHERTEXTBYTES 1088
#define JADE_KEM_KYBER_KYBER768_AMD64_REF_BYTES           32

int cryptolib_kyber768_amd64_ref_kem_keypair(uint8_t *pk, uint8_t *sk);

int cryptolib_kyber768_amd64_ref_kem_enc(uint8_t *ct, uint8_t *ss, const uint8_t *pk);

int cryptolib_kyber768_amd64_ref_kem_dec(uint8_t *ss, const uint8_t *ct, const uint8_t *sk);

#endif
#ifndef JADE_KEM_KYBER_KYBER512_AMD64_AVX2_API_H
#define JADE_KEM_KYBER_KYBER512_AMD64_AVX2_API_H

#include <stdint.h>

#define JADE_KEM_KYBER_KYBER512_AMD64_AVX2_SECRETKEYBYTES  1632
#define JADE_KEM_KYBER_KYBER512_AMD64_AVX2_PUBLICKEYBYTES  800
#define JADE_KEM_KYBER_KYBER512_AMD64_AVX2_CIPHERTEXTBYTES 768
#define JADE_KEM_KYBER_KYBER512_AMD64_AVX2_BYTES           32
#define JADE_KEM_KYBER_KYBER512_AMD64_AVX2_ALGNAME         "Kyber512"

int jade_kem_kyber_kyber512_amd64_avx2_keypair(uint8_t *pk, uint8_t *sk);

int jade_kem_kyber_kyber512_amd64_avx2_enc(uint8_t *ct, uint8_t *ss, const uint8_t *pk);

int jade_kem_kyber_kyber512_amd64_avx2_dec(uint8_t *ss, const uint8_t *ct, const uint8_t *sk);

#endif
#ifndef JADE_KEM_KYBER_KYBER512_AMD64_REF_H
#define JADE_KEM_KYBER_KYBER512_AMD64_REF_H

#define JADE_KEM_KYBER_KYBER512_AMD64_REF_SECRETKEYBYTES  2400
#define JADE_KEM_KYBER_KYBER512_AMD64_REF_PUBLICKEYBYTES  1184
#define JADE_KEM_KYBER_KYBER512_AMD64_REF_CIPHERTEXTBYTES 1088
#define JADE_KEM_KYBER_KYBER512_AMD64_REF_BYTES           32

int jade_kem_kyber_kyber512_amd64_ref_keypair(uint8_t *pk, uint8_t *sk);

int jade_kem_kyber_kyber512_amd64_ref_enc(uint8_t *ct, uint8_t *ss, const uint8_t *pk);

int jade_kem_kyber_kyber512_amd64_ref_dec(uint8_t *ss, const uint8_t *ct, const uint8_t *sk);

#endif
#ifndef JADE_SCALARMULT_CURVE25519_AMD64_REF4_API_H
#define JADE_SCALARMULT_CURVE25519_AMD64_REF4_API_H

#define JADE_SCALARMULT_CURVE25519_AMD64_REF4_BYTES 32
#define JADE_SCALARMULT_CURVE25519_AMD64_REF4_SCALARBYTES 32
#define JADE_SCALARMULT_CURVE25519_AMD64_REF4_ALGNAME "Curve25519"

#include <stdint.h>

int jade_scalarmult_curve25519_amd64_ref4(
 uint8_t *r,
 uint8_t *k,
 uint8_t *u
);

int jade_scalarmult_curve25519_amd64_ref4_base(
 uint8_t *r,
 uint8_t *k
);

// TODO : to be replaced for opt. Jasmin implementation
int jade_scalarmult_curve25519_amd64_ref4_base(
 uint8_t *r,
 uint8_t *k
)
{
  uint8_t basepoint[32] = {9};
  int res = jade_scalarmult_curve25519_amd64_ref4(r,k,basepoint);
  return res;
}

#endif
#ifndef JADE_SCALARMULT_CURVE25519_AMD64_MULX_API_H
#define JADE_SCALARMULT_CURVE25519_AMD64_MULX_API_H

#define JADE_SCALARMULT_CURVE25519_AMD64_MULX_BYTES 32
#define JADE_SCALARMULT_CURVE25519_AMD64_MULX_SCALARBYTES 32
#define JADE_SCALARMULT_CURVE25519_AMD64_MULX_ALGNAME "Curve25519"

#include <stdint.h>

int jade_scalarmult_curve25519_amd64_mulx(
 uint8_t *r,
 uint8_t *k,
 uint8_t *u
);

int jade_scalarmult_curve25519_amd64_mulx_base(
 uint8_t *r,
 uint8_t *k
);

// TODO : to be replaced for opt. Jasmin implementation
int jade_scalarmult_curve25519_amd64_mulx_base(
 uint8_t *r,
 uint8_t *k
)
{
  uint8_t basepoint[32] = {9};
  int res = jade_scalarmult_curve25519_amd64_mulx(r,k,basepoint);
  return res;
}

#endif
#ifndef JADE_SCALARMULT_CURVE25519_AMD64_REF5_API_H
#define JADE_SCALARMULT_CURVE25519_AMD64_REF5_API_H

#define JADE_SCALARMULT_CURVE25519_AMD64_REF5_BYTES 32
#define JADE_SCALARMULT_CURVE25519_AMD64_REF5_SCALARBYTES 32
#define JADE_SCALARMULT_CURVE25519_AMD64_REF5_ALGNAME "Curve25519"

#include <stdint.h>

int jade_scalarmult_curve25519_amd64_ref5(
 uint8_t *r,
 uint8_t *k,
 uint8_t *u
);

int jade_scalarmult_curve25519_amd64_ref5_base(
 uint8_t *r,
 uint8_t *k
);

// TODO : to be replaced for opt. Jasmin implementation
int jade_scalarmult_curve25519_amd64_ref5_base(
 uint8_t *r,
 uint8_t *k
)
{
  uint8_t basepoint[32] = {9};
  int res = jade_scalarmult_curve25519_amd64_ref5(r,k,basepoint);
  return res;
}

#endif
#ifndef JADE_ONETIMEAUTH_POLY1305_AMD64_AVX2_API_H
#define JADE_ONETIMEAUTH_POLY1305_AMD64_AVX2_API_H

#define JADE_ONETIMEAUTH_POLY1305_AMD64_AVX2_BYTES 16
#define JADE_ONETIMEAUTH_POLY1305_AMD64_AVX2_KEYBYTES 32
#define JADE_ONETIMEAUTH_POLY1305_AMD64_AVX2_ALGNAME "Poly1305"

#include <stdint.h>

int jade_onetimeauth_poly1305_amd64_avx2(
 uint8_t *out, /*BYTES*/
 uint8_t *in,
 uint64_t inlen,
 uint8_t *key /*KEYBYTES*/
);

int jade_onetimeauth_poly1305_amd64_avx2_verify(
 uint8_t *h, /*BYTES*/
 uint8_t *in,
 uint64_t inlen,
 uint8_t *key /*KEYBYTES*/
);

#endif
#ifndef JADE_ONETIMEAUTH_POLY1305_AMD64_AVX_API_H
#define JADE_ONETIMEAUTH_POLY1305_AMD64_AVX_API_H

#define JADE_ONETIMEAUTH_POLY1305_AMD64_AVX_BYTES 16
#define JADE_ONETIMEAUTH_POLY1305_AMD64_AVX_KEYBYTES 32
#define JADE_ONETIMEAUTH_POLY1305_AMD64_AVX_ALGNAME "Poly1305"

#include <stdint.h>

int jade_onetimeauth_poly1305_amd64_avx(
 uint8_t *out, /*BYTES*/
 uint8_t *in,
 uint64_t inlen,
 uint8_t *key /*KEYBYTES*/
);

int jade_onetimeauth_poly1305_amd64_avx_verify(
 uint8_t *h, /*BYTES*/
 uint8_t *in,
 uint64_t inlen,
 uint8_t *key /*KEYBYTES*/
);

#endif
#ifndef JADE_ONETIMEAUTH_POLY1305_AMD64_REF_API_H
#define JADE_ONETIMEAUTH_POLY1305_AMD64_REF_API_H
#define JADE_ONETIMEAUTH_POLY1305_AMD64_REF_BYTES 16
#define JADE_ONETIMEAUTH_POLY1305_AMD64_REF_KEYBYTES 32
#define JADE_ONETIMEAUTH_POLY1305_AMD64_REF_ALGNAME "Poly1305"

#include <stdint.h>

int jade_onetimeauth_poly1305_amd64_ref(
 uint8_t *out, /*BYTES*/
 uint8_t *in,
 uint64_t inlen,
 uint8_t *key /*KEYBYTES*/
);

int jade_onetimeauth_poly1305_amd64_ref_verify(
 uint8_t *h, /*BYTES*/
 uint8_t *in,
 uint64_t inlen,
 uint8_t *key /*KEYBYTES*/
);

#endif
#ifndef JADE_XOF_SHAKE256_AMD64_SPEC_API_H
#define JADE_XOF_SHAKE256_AMD64_SPEC_API_H

#define JADE_XOF_SHAKE256_AMD64_SPEC_ALGNAME "SHAKE256"

#include <stdint.h>

int jade_xof_shake256_amd64_spec(
 uint8_t *out,
 uint64_t outlen,
 uint8_t *in,
 uint64_t inlen
);

#endif
#ifndef JADE_XOF_SHAKE256_AMD64_AVX2_API_H
#define JADE_XOF_SHAKE256_AMD64_AVX2_API_H

#define JADE_XOF_SHAKE256_AMD64_AVX2_ALGNAME "SHAKE256"

#include <stdint.h>

int jade_xof_shake256_amd64_avx2(
 uint8_t *out,
 uint64_t outlen,
 uint8_t *in,
 uint64_t inlen
);

#endif
#ifndef JADE_XOF_SHAKE256_AMD64_REF_API_H
#define JADE_XOF_SHAKE256_AMD64_REF_API_H

#define JADE_XOF_SHAKE256_AMD64_REF_ALGNAME "SHAKE256"

#include <stdint.h>

int jade_xof_shake256_amd64_ref(
 uint8_t *out,
 uint64_t outlen,
 uint8_t *in,
 uint64_t inlen
);

#endif
#ifndef JADE_XOF_SHAKE256_AMD64_REF1_API_H
#define JADE_XOF_SHAKE256_AMD64_REF1_API_H

#define JADE_XOF_SHAKE256_AMD64_REF1_ALGNAME "SHAKE256"

#include <stdint.h>

int jade_xof_shake256_amd64_ref1(
 uint8_t *out,
 uint64_t outlen,
 uint8_t *in,
 uint64_t inlen
);

#endif
#ifndef JADE_XOF_SHAKE128_AMD64_AVX2_API_H
#define JADE_XOF_SHAKE128_AMD64_AVX2_API_H

#define JADE_XOF_SHAKE128_AMD64_AVX2_ALGNAME "SHAKE128"

#include <stdint.h>

int jade_xof_shake128_amd64_avx2(
 uint8_t *out,
 uint64_t outlen,
 uint8_t *in,
 uint64_t inlen
);

#endif
#ifndef JADE_XOF_SHAKE128_AMD64_REF_API_H
#define JADE_XOF_SHAKE128_AMD64_REF_API_H

#define JADE_XOF_SHAKE128_AMD64_REF_ALGNAME "SHAKE128"

#include <stdint.h>

int jade_xof_shake128_amd64_ref(
 uint8_t *out,
 uint64_t outlen,
 uint8_t *in,
 uint64_t inlen
);

#endif
